/*	$UxDriver: am79c930ioctl.h,v 1.9 1999/04/15 04:31:31 cas Exp $	*/

/*
 * Copyright (c) 1998,1999 Trans New Technology, Inc. and
 *                         Hiroki NAKANO <cas@trans-nt.com>
 * All rights reserved.
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that this notice is retained,
 * the conditions in the following notices are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by
 *	Trans New Technology, Inc. (in Japan)
 *
 *
 * THIS SOFTWARE IS PROVIDED BY TRANS NEW TECHNOLOGY, INC. ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL TRANS NEW TECHNOLOGY, INC. BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/*
 * ICOM UX-136 Wireless LAN Card
 *   (AMD Am79C930 IEEE802.11 Firmware API ver.1.0)
 *
 *	ioctl definitions
 */

struct uxioctl_int {
	struct ifreq ifr;
	int i;
};

struct uxioctl_essid {
	struct ifreq ifr;
	unsigned int length;
	u_int8_t essid[32];
};
#define	UXIOCSESSID	_IOW( 'i', 230, struct uxioctl_essid)
#define	UXIOCGESSID	_IOWR('i', 231, struct uxioctl_essid)

/* if packet captured by bpf is raw 802.11? (otherwise ethernet) */
#define	UXIOCSRAWMACBPF	_IOW( 'i', 232, struct uxioctl_int)

/* for debug */

#define	UXIOCWRITEMEM
struct uxioctl_execcmd {
	struct ifreq ifr;
	struct Am79C930_Command_Block cb;
};

struct uxioctl_cardmem {
	struct ifreq ifr;
	unsigned int addr, size;
	u_int8_t data[256];
};

#define	UXIOCEXECCMD	_IOWR('i', 200, struct uxioctl_execcmd)
#define	UXIOCREADMEM	_IOWR('i', 201, struct uxioctl_cardmem)

#define	UXIOCREADIO
#define	UXIOCWRITEIO
#define	UXIOCGETMIB
#define	UXIOCSETMIB

/* EOF */
