/*	$UxDriver: am79c930var.h,v 1.11 1999/04/15 11:41:57 cas Exp $	*/

/*
 * Copyright (c) 1998,1999 Trans New Technology, Inc. and
 *                         Hiroki NAKANO <cas@trans-nt.com>
 * All rights reserved.
 *
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that this notice is retained,
 * the conditions in the following notices are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by
 *	Trans New Technology, Inc. (in Japan)
 *
 *
 * THIS SOFTWARE IS PROVIDED BY TRANS NEW TECHNOLOGY, INC. ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL TRANS NEW TECHNOLOGY, INC. BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

/*
 * ICOM UX-136 Wireless LAN Card
 *   (AMD Am79C930 Firmware ver.2.0-Japan)
 *
 *   BSD driver module independent from OS
 *
 */

/* bss information */
struct	ux_bssinfo {
	int		uxbss_valid;
	ux_uint8_t	uxbss_essid[34];
	ux_uint48_t	uxbss_bssid;
	ux_uint64_t	uxbss_timestamp;
	ux_uint32_t	uxbss_reftime;
};

/*
 *  common device structure
 */

#define	UX_DEVNAME	"ux"

struct	ux_softc {
	struct	device	ux_dev;
#define ux_devname	ux_dev.dv_xname
	struct	arpcom	ux_arpcom;
#define	ux_if	ux_arpcom.ac_if		/* network-visible interface */

	int		ux_enabled;
	
	/* for reseting chip */
	int		ux_prevsts;	/* previous Self_Test_Status */
	int		ux_rsttimocnt;	/* resettimo counter */

	/* MAC address */
	ux_uint48_t	ux_macaddr;
	ux_uint48_t	ux_bssid;
	ux_uint8_t	ux_essid[34];

	/* BSS management */
	struct ux_bssinfo ux_nowbss;

	/* tx buffers on the card */
	u_int32_t	ux_txbufoffset;
	u_int32_t	ux_txbufsize;
	u_int8_t	ux_txbuffreemap[8];

	/* rx buffers on the card */
	u_int32_t	ux_rxbufoffset;
	u_int32_t	ux_rxbufsize;

	/* descriptors' chain */
	u_int32_t	ux_txdeschead;
	u_int32_t	ux_txdesctail;

	u_int32_t	ux_rxdeschead;
	u_int32_t	ux_rxdeschead_mgmt;

	/* if we give raw 802.11 packet to bpf ? (otherwise stripped) */
	int		ux_rawmacbpf;
};

/* standard entries */
int	ux_intr		(struct ux_softc *);
void	ux_start	(struct ux_softc *);
void	ux_reset	(struct ux_softc *);
int	ux_init		(struct ux_softc *);
int	ux_ioctl	(struct ux_softc *, u_long, caddr_t);

/* attach logical interface */
void	ux_attach	(struct ux_softc *);

/* enable/disable real device (hardware) */
void	ux_enable	(struct ux_softc *);
void	ux_disable	(struct ux_softc *);

/* EOF */
